nlp = ADNLPModel(x->dot(x,x), zeros(2))
@test !has_bounds(nlp)
@test !bound_constrained(nlp)
@test unconstrained(nlp)
@test !linearly_constrained(nlp)
@test !equality_constrained(nlp)
@test !inequality_constrained(nlp)

nlp = ADNLPModel(x->dot(x,x), zeros(2), zeros(2), zeros(2))
@test has_bounds(nlp)
@test bound_constrained(nlp)
@test !unconstrained(nlp)
@test !linearly_constrained(nlp)
@test !equality_constrained(nlp)
@test !inequality_constrained(nlp)

nlp = ADNLPModel(x->dot(x,x), zeros(2), x->[prod(x)-1], [0.0], [0.0])
@test !has_bounds(nlp)
@test !bound_constrained(nlp)
@test !unconstrained(nlp)
@test !linearly_constrained(nlp)
@test equality_constrained(nlp)
@test !inequality_constrained(nlp)

nlp = ADNLPModel(x->dot(x,x), zeros(2), x->[prod(x)-1], [0.0], [1.0])
@test !has_bounds(nlp)
@test !bound_constrained(nlp)
@test !unconstrained(nlp)
@test !linearly_constrained(nlp)
@test !equality_constrained(nlp)
@test inequality_constrained(nlp)

nlp = ADNLPModel(x->dot(x,x), zeros(2), x->[prod(x)-1; sum(x)-1], zeros(2), [0.0; Inf])
@test !has_bounds(nlp)
@test !bound_constrained(nlp)
@test !unconstrained(nlp)
@test !linearly_constrained(nlp)
@test !equality_constrained(nlp)
@test !inequality_constrained(nlp)

nlp = ADNLPModel(x->dot(x,x), zeros(2), x->[sum(x)-1], zeros(1), zeros(1), lin=[1])
@test !has_bounds(nlp)
@test !bound_constrained(nlp)
@test !unconstrained(nlp)
@test linearly_constrained(nlp)
@test equality_constrained(nlp)
@test !inequality_constrained(nlp)

nlp = ADNLPModel(x->dot(x,x), zeros(2), zeros(2), ones(2), x->[sum(x)-1], zeros(1), zeros(1), lin=[1])
@test has_bounds(nlp)
@test !bound_constrained(nlp)
@test !unconstrained(nlp)
@test linearly_constrained(nlp)
@test equality_constrained(nlp)
@test !inequality_constrained(nlp)
